/**
 * @file
 * Written by Henri MEDOT <henri.medot[AT]absyx[DOT]fr>
 * http://www.absyx.fr
 *
 * Inspired by Resumable.js
 * http://resumablejs.com
 *
 * Released under the GPLv2 license.
 */

!function(e){"use strict";var t=function(e){var t,n,i,r=arguments,s=r.length;for(t=1;s>t;t++){n=r[t];for(i in n)e[i]=n[i]}return e},n=function(e,t){for(var n=0,i=e.length;i>n&&t(e[n])!==!1;n++);},i=function(e,t){for(var n=0,i=t.length;i>n;n++)if(t[n]===e)return n;return-1},r=function(e,t,n){e.addEventListener(t,n,!1)},s=function(e){e.preventDefault()},u=function(){return(new Date).getTime()},a=function(e,t){var r=e.options,s=r.maxFiles,u=e.files,a=[];n(t,function(t){var n=a.length;if(1==s&&n||s>1&&u.length+n==s)return!1;var o=new C(e,t);if(!e.getFileById(o.id)){var l,f=o.size,p=r.maxFileSize;if(!f||p&&f>p)l="size";else{var d=r.extensions;d&&i(o.extension,d)<0&&(l="extension")}if(l)c(e,"resupaddedfileerror",[o,l]);else{var h=r.fileValidator;(!h||h(o))&&a.push(o)}}});var l=a.length;if(l){if(1==s&&u.length){var f=e.uploading;e.stop(),e.removeFile(u[0]),e.uploading=f}e.files=u.concat(a),o(e)}c(e,"resupfilesadded",[a,t.length-l])},o=function(e){if(e.uploading){e.t0=0,p(e);var t=e.queue=[],i=0,r=e.options.maxRequests;if(n(e.files,function(e){e.xhr?i++:t.push(e)}),i||t.length)for(;r>i&&t.length;)d(t.shift()),i++;else f(e)}},l=function(t){var n=t.r;if(n.uploading){p(n);var i=n.queue;if(1&t.status){if(t.retries>=4)return t.status=8,c(n,"resupfileerror",[t]),o(n),e;i.push(t)}var r=i.shift();if(r)d(r);else{var s,u=n.files,a=u.length;for(s=0;a>s;s++)if(u[s].xhr)return;f(n)}}},f=function(e){e.uploading=!1;var t=[],i=[];n(e.files,function(e){(4==e.status?t:i).push(e)}),c(e,"resupended",[t,i])},p=function(e){c(e,"resupprogress")},d=function(n){var i=n.status;if(12&i)return l(n),e;var s,a=n.r,o=a.options,f=a.url,d=t({},o.query,{resup_file_id:n.id}),h=new XMLHttpRequest;switch(r(h,"loadstart",function(){n.xhrp=0,n.xhr=h}),r(h,"loadend",function(){if(n.xhr=null,200!=h.status)n.sa||(n.retries++,l(n));else{var e=h.responseText;/^\d+$/.test(e)?(e=+e,3==n.status&&(e==n.uploadedChunks+1?n.retries=0:(a.t0=0,n.retries++)),n.uploadedChunks=e,n.status=e==n.totalChunks?4:3):(n.retries++,n.status=1),l(n)}}),i){case 0:n.status=1;case 1:t(d,{resup_file_name:n.name,resup_file_size:n.size});var c=[];for(s in d)c.push(s+"="+encodeURIComponent(d[s]));h.open("GET",f+(f.indexOf("?")<0?"?":"&")+c.join("&")+"&_"+u()),h.timeout=1e4,h.send();break;case 3:r(h.upload,"progress",function(e){if(e.lengthComputable){var t=n.xhrb=e.loaded;n.xhrp=t/e.total,p(a)}});var v=n.uploadedChunks,g=o.chunkSize,m=v*g,x=new FormData;t(d,{resup_file_id:n.id,resup_chunk_number:v+1});for(s in d)x.append(s,d[s]);x.append(o.inputName,n._file.slice(m,v<n.totalChunks-1?m+g:n.size)),h.open("POST",f),h.timeout=6e4,h.send(x)}},h=function(e){var t=e.xhr;t&&(e.sa=!0,t.abort(),e.sa=!1,e.xhr=null)},c=function(e,t,n){var i=e["on"+t];i&&i.apply(e,n)},v=window.Resup=function(e,n){var i=this,u=i.options=t({inputName:"resup_chunk",chunkSize:1048576,maxRequests:3,query:{}},n||{}),o=u.drop,l=u.maxFiles,f=i.input=document.createElement("input");f.type="file",f.multiple=null==l||l>1,r(f,"change",function(){a(i,f.files),f.value=""}),i.url=e,i.files=[],o&&(r(o,"dragover",s),r(o,"drop",function(e){a(i,e.dataTransfer.files),s(e)}))},g=typeof e,m=typeof File!==g&&typeof FileList!==g&&typeof FormData!==g;if(m){var x=File.prototype,k=x.webkitSlice||x.mozSlice||x.slice;m=!!k,x.slice=k}v.support=m;var z=v.prototype;z.upload=function(){var e=this;!e.uploading&&e.files.length&&(e.uploading=!0,o(e))},z.retry=function(){var e,t=this;n(t.files,function(t){t.retries=0,8==t.status&&(t.status=0,e=!0)}),e&&o(t),t.upload()},z.stop=function(){var e=this;e.uploading&&(e.uploading=!1,n(e.files,h))},z.removeFile=function(e){var t=this,n=t.files,r=i(e,n);r>-1&&(h(e),n.splice(r,1),o(t))},z.getFileById=function(e){var t,n,i=this.files,r=i.length;for(t=0;r>t;t++)if(n=i[t],n.id==e)return n},z.getProgress=function(){var e=0,t=0;return n(this.files,function(n){if(n.status<8){e+=n.totalChunks,t+=n.uploadedChunks;var i=n.xhrp;n.xhr&&i&&(t+=i)}}),e?t/e:0},z.getTime=function(){var e=this;if(e.uploading){var t,n,i,r,s,a,o=e.t0,l=e.p0,f=u(),p=0,d=0,h=e.options.chunkSize,c=e.files,v=c.length;for(n=0;v>n;n++){if(i=c[n],r=i.status,1>=r)return e.t0=0,-1;8>r&&(s=i.size,p+=s,a=i.uploadedChunks,d+=a<i.totalChunks?a*h+(i.xhr&&i.xhrp?i.xhrb:0):s)}if(t=d/p,o)return t>l?Math.round((f-o)*(1-t)/(t-l)/1e3):-1;e.t0=f,e.p0=t}return-1};var C=function(e,t){var n=this;n.r=e,n._file=t,n.name=t.fileName||t.name,n.size=t.fileSize||t.size,n.date=t.lastModifiedDate,n.uploadedChunks=0,n.status=0,n.retries=0;var i=n.name.split("."),r=i.length;n.extension=r>1?i[r-1].toLowerCase():"";var s=0,a=n.date;if(a instanceof Date){var s=a.getTime();u()-s<1e3&&(s=0)}n.id=[n.size,s,encodeURIComponent(n.name).replace(/[^\w%]/g,function(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()})].join("-"),n.totalChunks=Math.ceil(n.size/e.options.chunkSize)}}();